﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Windows;

namespace IgDoughnutTester
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        #region Members

        private static ServiceProvider _Services = new ServiceProvider();

        #endregion

        #region Properties

        public static ServiceProvider Services
        {
            get { return _Services; }
        }

        #endregion

        protected override void OnStartup(StartupEventArgs e)
        {
            // register common services
            Services.RegisterService<IWindowService>(new WpfWindowService());
            base.OnStartup(e);

            Current.ShutdownMode = ShutdownMode.OnExplicitShutdown;

            var windowService = Services.GetService<IWindowService>();

            var mainWindow = new MainWindow { DataContext = new MainViewModel() };
            Current.ShutdownMode = ShutdownMode.OnMainWindowClose;
            Current.MainWindow = mainWindow;
            mainWindow.Show();
        }
    }
}
